KontoPruefziffernrechnung
Date: 2015-04-26

de.jost_net.OBanToo.PruefziffernCheck

## Class KontoPruefziffernrechnung

- java.lang.Object
- - de.jost_net.OBanToo.PruefziffernCheck.KontoPruefziffernrechnung

-     public final class KontoPruefziffernrechnung
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `KontoPruefziffernrechnung()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static PZRet` | `checkAccountCRC(java.lang.String alg, java.lang.String blz, java.lang.String number)` Überprüft, ob gegebene BLZ und Kontonummer zueinander passen.
    `static PZRet` | `checkAccountCRCByAlg(java.lang.String alg, java.lang.String blz, java.lang.String number)` Überprüfen einer Kontonummer mit einem gegebenen CRC-Algorithmus.
    `private static java.lang.reflect.Method` | `getAccountCRCMethodByAlg(java.lang.String alg)`
    `private static int[]` | `string2Ints(java.lang.String st, int target_length)` Used to convert a blz or an account number to an array of ints, one array element per digit.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### KontoPruefziffernrechnung

          public KontoPruefziffernrechnung()

  - ### Method Detail

    - #### getAccountCRCMethodByAlg

          private static java.lang.reflect.Method getAccountCRCMethodByAlg(java.lang.String alg)
                                                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### checkAccountCRC

          public static PZRet checkAccountCRC(java.lang.String alg,
                              java.lang.String blz,
                              java.lang.String number)
                                       throws java.lang.Exception

      Überprüft, ob gegebene BLZ und Kontonummer zueinander passen. Bei diesem Test wird wird die in die Kontonummer "eingebaute" Prüziffer verifiziert. Anhand der BLZ wird ermittelt, welches Prüfzifferverfahren zur Überprüfung eingesetzt werden muss.

      Ein positives Ergebnis dieser Routine bedeutet nicht, dass das entsprechende Konto bei der Bank existiert, sondern nur, dass die Kontonummer bei der entsprechenden Bank prinzipiell gültig ist.

      Parameters:
        `blz` - die Bankleitzahl der Bank, bei der das Konto geführt wird
        `number` - die zu überprüfende Kontonummer
      Returns:
        `true` wenn die Kontonummer nicht verifiziert werden kann (z.B. weil das jeweilige Prüfzifferverfahren noch nicht in HBCI4Java implementiert ist) oder wenn die Prüfung erfolgreich verläuft; `false` wird immer nur dann zurückgegeben, wenn tatsächlich ein Prüfzifferverfahren zum Überprüfen verwendet wurde und die Prüfung einen Fehler ergab
      Throws:
        `java.lang.Exception`

    - #### checkAccountCRCByAlg

          public static PZRet checkAccountCRCByAlg(java.lang.String alg,
                                   java.lang.String blz,
                                   java.lang.String number)
                                            throws java.lang.Exception

      Überprüfen einer Kontonummer mit einem gegebenen CRC-Algorithmus. Diese Methode wird intern von HBCIUtils#checkAccountCRC(String,String) aufgerufen und kann für Debugging-Zwecke auch direkt benutzt werden.
      Parameters:
        `alg` - Nummer des zu verwendenden Prüfziffer-Algorithmus (siehe Datei `blz.properties`).
        `blz` - zu überprüfende Bankleitzahl
        `number` - zu überprüfende Kontonummer
      Returns:
        `false`, wenn der Prüfzifferalgorithmus für die angegebene Kontonummer einen Fehler meldet, sonst `true` (siehe dazu auch checkAccountCRC(String, String))
      Throws:
        `java.lang.Exception`

    - #### string2Ints

          private static int[] string2Ints(java.lang.String st,
                          int target_length)

      Used to convert a blz or an account number to an array of ints, one array element per digit.